//******************************************************************************
//!
//! @file $Id: mc_drv.c 2046 2008-09-12 13:50:27Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief ײ  : Init, PWMȂ
//!
//! @todo
//! @bug
//******************************************************************************

/* 쌠 (c) 2008, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ _______________________________________________________________

#include "config.h"

#include "mc_drv.h"
#include "mc_interface.h"
#include "mc_control.h"

#include "psc\psc_drv.h"
#include "adc\adc_drv.h"
#include "dac\dac_drv.h"
#include "pll\pll_drv.h"
#include "comparator\comparator_drv.h"

#define PSWAP0		2
#define PSWAP1		3
#define PSWAP2		4

Bool overcurrent =	FALSE;

U8 count = 1;						// countϐn̎ł̕ϑxvZɎgp܂B
U16 average = 0;
static volatile U8 timer0_ext = 0;	// timer0_extϐ8ޯČv16ޯČvЭڰĂ̂Ɏgp܂B

static Bool inrush_mask_flag = FALSE;
static U16 inrush_delay = 0;

static U16 stored_time = 0;

static U32 top_average = 200;

static U8 motor_step;

volatile Bool g_tick = FALSE;		//!< ̎l̐Ɏgp܂B

Bool current_EOC = FALSE;			// ϊI׸

static char State = CONV_INIT;		// A/Dϊv敔̏
static char ADC_State = FREE;		// BUSY=sAFREE=񑖍s(~)

/******************************************************************************/
/******************************************************************************/
/*		ʰ޳														  */
/******************************************************************************/
/******************************************************************************/


//! @brief mc_init_HW : ʰ޳
//! @post ʰ޳̏
void mc_init_HW(void)
{
  // (PSCo͂Ɏgp)o݌`Ԑݒ
  // PD0UH, PB7UL
  // PC0VH, PB6VL
  // PB0WH, PB1WL

  // MOS-FET쓮ɑ΂x(Low)o
  PORTB &= ~(1<<PORTB7 | 1<<PORTB6 | 1<<PORTB1 | 1<<PORTB0);
  PORTC &= ~(1<<PORTC0);
  PORTD &= ~(1<<PORTD0);

/* (폜ׂ)ޯޗp */
  PORTB |= (1<<PORTB4)|(1<<PORTB3);		/* mȂޯޗpPB4PB3ٱߊ */
  PORTC |= (1<<PORTC3);					/* mȂޯޗpPC3ٱߊ */

/* Orpٱ (rgpɍ폜) */ 
#ifdef USE_INTERNAL_COMPARATORS
#else
  PORTD |= (1<<PORTD7)|(1<<PORTD5);
  PORTC |= (1<<PORTC6);
#endif

  // ߰B :
  DDRB = (1<<DDB7)|(1<<DDB6)|(1<<DDB1)|(1<<DDB0);
  // ߰C :
  DDRC = (1<<DDC0);
  // ߰D :
  DDRD = (1<<DDD0);
  // ߰E : /* (폜ׂ) */
  DDRE |= (1<<DDE2)|(1<<DDE1);

  Init_PC7();	/* PC7͉ߓd̕\Ɏgp܂B */

  // 1Ɋւ޼ٓ͂֎~
  DIDR1 = (1<<ADC9D)|(1<<ADC8D);

  // r0,1,2Ɋւ޼ٓ͂֎~ (Orgpɍ폜)
#ifdef USE_INTERNAL_COMPARATORS
  DIDR0 = (1<<ADC6D)|(1<<ADC5D)|(1<<ADC3D)|(1<<ADC2D);
  DIDR1 = (1<<ADC10D)|(1<<ACMP0D);
#endif

  // VrefI
//  init_vref_source ();

//  init_adc();
  Adc_config();
  Amp1_config();

  //  : PWM̑OD/AϊƉߓd
  // D/Aϊ͉ߓd(rpd)Ɏgp܂B
  Dac_config();
  /* ߓdِݒ */
  Dac_set_8_bits(IMAX);
    
  mc_init_timer0();
  mc_init_timer1();

  Comp_0_config();
  Comp_1_config();
  Comp_2_config();
  
  // ΰيmł̕ωoPCINT3,4,11gp
  PCMSK0 = (1<<PCINT4)|(1<<PCINT3);
  PCMSK1 = (1<<PCINT11);
  PCICR = (1<<PCIE1)|(1<<PCIE0);

//  Start_pll_32_mega();	// 32MHz PLLo͎gpPLLJn
  Start_pll_64_mega();		// 64MHz PLLo͎gpPLLJn
  Wait_pll_ready();

  // => PSCx_Init(Period_Half, Dutyx0_Half, Synchro, Dutyx1_Half)
  PSC_Init();
}

//! @brief PSC : config.hł̐ݒɏ]PSC
void PSC_Init (void)
{
  Psc_set_module_A(A_SA_VAL,A_RA_VAL,A_SB_VAL);
  Psc_set_module_B(B_SA_VAL,B_RA_VAL,B_SB_VAL);
  Psc_set_module_C(C_SA_VAL,C_RA_VAL,C_SB_VAL);
  Psc_set_register_RB(RB_VAL);

  Psc_config();

  Psc_config_input_0(PSC_OVERLAP_ENABLE,\
					 PSC_USE_PIN,\
					 PSC_USE_LOW_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_SYNCHRONOUS_OUTPUT_CONTROL,\
					 PSC_INPUT_NO_ACTION);

  Psc_config_input_1(PSC_OVERLAP_ENABLE,\
					 PSC_USE_COMPARATOR,\
					 PSC_USE_HIGH_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_SYNCHRONOUS_OUTPUT_CONTROL,\
					 PSC_INPUT_NO_ACTION);

  Psc_config_input_2(PSC_OVERLAP_ENABLE,\
					 PSC_USE_PIN,\
					 PSC_USE_LOW_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_SYNCHRONOUS_OUTPUT_CONTROL,\
					 PSC_INPUT_NO_ACTION);

  PIFR = (1<<PEV2)|(1<<PEV1)|(1<<PEV0)|(1<<PEOP);
  PIM = (1<<PEVE1);

  Psc_run();
}

/***************************************************************************/
/***************************************************************************/
/*		d@̑(])pS֐									   */
/***************************************************************************/
/***************************************************************************/

/**
* @brief	ΰيm̒l(1`6)擾
* @param	unsigned char(ΰيm̒l)Ԃ܂B
* @pre		߰PBPĎ`Ԑݒ
* @post		ʒuɐVl
*/
Motor_Position mc_get_hall(void)
{
  return HALL_SENSOR_VALUE();
}

/**
 * @brief	O (ΰيmAAݐ؂ւ`)
 * @pre		Ǒ݂`Ԑݒ()
 * @post	ΰٕϐɐVl
 */
#ifdef __GNUC__
  ISR(HALL_A())
#else
#pragma vector = HALL_A()
__interrupt void mc_hall_a(void)
#endif
{
//  if (ramp_up == TRUE) mc_switch_commutation(HALL_SENSOR_VALUE());
//  mc_switch_commutation(HALL_SENSOR_VALUE());
  // ΰيmA̗オ[ł̐葬x
  if (PINC&(1<<PORTC3))
  {
	mc_estimation_speed();
  }
}

/**
 * @brief	O (ΰيmBAݐ؂ւ`)
 * @pre		Ǒ݂`Ԑݒ()
 * @post	ΰٕϐɐVl
 */
#ifdef __GNUC__
  ISR(HALL_B())
#else
#pragma vector = HALL_B()
__interrupt void mc_hall_b(void)
#endif
{
//  if (ramp_up == TRUE) mc_switch_commutation(HALL_SENSOR_VALUE());
//  mc_switch_commutation(HALL_SENSOR_VALUE());
}

/**
* @brief	JԂɂČvZꂽlɏ]PSCޭè ْlݒ
*/
void mc_duty_cycle(U8 level)
{
  U8 duty;
  duty = level;

#if ((CURRENT_DECAY == SLOW_DECAY_SYNCHRONOUS)||(CURRENT_DECAY == FAST_DECAY_SYNCHRONOUS))
  U8 dutydt;   /* duty with dead time */
  if (duty >= DEADTIME) dutydt = duty - DEADTIME;
#endif

  Psc_lock();

  // Duty=  0ޭè    0%
  // Duty=255ޭè  100%
 
#if (CURRENT_DECAY == FAST_DECAY)
  Psc_set_module_A(duty,A_RA_VAL,duty);
  Psc_set_module_B(duty,B_RA_VAL,duty);
  Psc_set_module_C(duty,C_RA_VAL,duty);
#else
#if ((CURRENT_DECAY == SLOW_DECAY_SYNCHRONOUS)||(CURRENT_DECAY == FAST_DECAY_SYNCHRONOUS))
  Psc_set_module_A(duty,A_RA_VAL,dutydt);
  Psc_set_module_B(duty,B_RA_VAL,dutydt);
  Psc_set_module_C(duty,C_RA_VAL,dutydt);
#else
  Psc_set_module_A(duty,A_RA_VAL,0);
  Psc_set_module_B(duty,B_RA_VAL,0);
  Psc_set_module_C(duty,C_RA_VAL,0);
#endif
#endif

  Psc_unlock();
}

/**
* @brief	o͂ɐ؂ւ(])lݒ
*
* @param	ʒu(1`6)ƕ(FORWARD܂BACKWARD)
*/
void mc_switch_commutation(Motor_Position position)
{
  // Ő(])邽߂ɓd@擾
  char direction = mci_get_motor_direction();

  // ͎gp҂d@nꍇɂ(])܂B
  if (mci_motor_is_running())
  {
	switch(position)
	{
	// ]qʒuɏ]
	  case MS_001:  {Set_Q1Q6();motor_step=MS_001;}
					break;
	  case MS_101:  {Set_Q1Q4();motor_step=MS_101;}
					break;
	  case MS_100:  {Set_Q5Q4();motor_step=MS_100;}
					break;
	  case MS_110:  {Set_Q5Q2();motor_step=MS_110;}
					break;
	  case MS_010:  {Set_Q3Q2();motor_step=MS_010;}
					break;
	  case MS_011:  {Set_Q3Q6();motor_step=MS_011;}
					break;
	  default : break;
	}
  }
  else
  {
	Set_none();		// SOFFɂ܂B
  }
}

/******************************************************************************/
/******************************************************************************/
/*		v1 : g_tick												  */
/******************************************************************************/
/******************************************************************************/

/**
* @brief	v1`Ԑݒ
*/
void mc_init_timer1(void)
{
  TCCR1A = 0;						// W߰ē,CTC
  TCCR1B = 1<<CS11 | 1<<CS10 ;		// CTC,64Ou(4s)Ŏn
  TCCR1C = 0;
}

/**
  * @brief	30荞
*/
#ifdef __GNUC__
  ISR(TIMER1_COMPA_vect)
#else
#pragma vector = TIMER1_COMPA_vect
__interrupt void thirty_degres_interrupt(void)
#endif
{
  char direction = mci_get_motor_direction();

  if (mci_motor_is_running())
  {
	switch(motor_step)
	{
	  case (MS_100):
		if (direction==CCW)  {Set_Q1Q4();motor_step=MS_101;}
		else                 {Set_Q5Q2();motor_step=MS_110;}
		break;
	  case (MS_110):
		if (direction==CCW)  {Set_Q5Q4();motor_step=MS_100;}
		else                 {Set_Q3Q2();motor_step=MS_010;}
		break;
	  case (MS_010):
		if (direction==CCW)  {Set_Q5Q2();motor_step=MS_110;}
		else                 {Set_Q3Q6();motor_step=MS_011;}
		break;
	  case (MS_011):
		if (direction==CCW)  {Set_Q3Q2();motor_step=MS_010;}
		else                 {Set_Q1Q6();motor_step=MS_001;}
		break;
	  case (MS_001):
		if (direction==CCW)  {Set_Q3Q6();motor_step=MS_011;}
		else                 {Set_Q1Q4();motor_step=MS_101;}
		break;
	  case (MS_101):
		if (direction==CCW)  {Set_Q1Q6();motor_step=MS_001;}
		else                 {Set_Q5Q4();motor_step=MS_100;}
		break;
	  default :
		Set_none();			// SOFFɂ܂B
		motor_step=MS_010;
		break;
	}
  }
}

/**
* @brief	x荞݂̍Ō
*/
#ifdef __GNUC__
  ISR(TIMER1_COMPB_vect)
#else
#pragma vector = TIMER1_COMPB_vect
__interrupt void demag_interrupt(void)
#endif
{
  switch(motor_step)
  {
	case (MS_100):
	  Enable_IT_comparator0();
	  break;
	case (MS_110):
	  Enable_IT_comparator1();
	  break;
	case (MS_010):
	  Enable_IT_comparator2();
	  break;
	case (MS_011):
	  Enable_IT_comparator0();
	  break;
	case (MS_001):
	  Enable_IT_comparator1();
	  break;
	case (MS_101):
	  Enable_IT_comparator2();
	  break;
	default :
	  Enable_IT_comparator2_1_0();
	  motor_step=MS_010;
	  break;
  }
}

#define ADVANCE 70

#ifdef __GNUC__
  ISR(ANACOMP0_vect)
#else
#pragma vector = ANA_COMP0_vect
__interrupt void mc_comparator_0(void)
#endif 
{
  U16 top;
  U16 tmp1;
  U16 tmp2;
  U8 temp;
  TCCR1B = 0 ;							// v1~
  temp = TCNT1L;
  top = (TCNT1H<<8) + temp;
  TCNT1H = 0;
  TCNT1L = 0;
  top_average = ((U32)top_average*15 + top ) >> 4;
  tmp1 = (top_average >> 1);
  tmp2 = tmp1 + (top_average >> 2);
//  tmp2 = tmp1 + 40;
/*  if (tmp1 > (4*ADVANCE))
  {
    tmp1 = tmp1 - ADVANCE;
    tmp2 = tmp2 - ADVANCE;
  }*/
  OCR1AH = MSB(tmp1);
  OCR1AL = LSB(tmp1);
  OCR1BH = MSB(tmp2);
  OCR1BL = LSB(tmp2);
  TCCR1B = 1<<CS11 | 1<<CS10 ;			// v1Jn
  Disable_IT_comparator2_1_0();

}

#ifdef __GNUC__
  ISR(ANACOMP1_vect)
#else
#pragma vector = ANA_COMP1_vect
__interrupt void mc_comparator_1(void)
#endif
{
  U16 top;
  U16 tmp1;
  U16 tmp2;
  U8 temp;
  TCCR1B = 0 ;							// v1~
  temp = TCNT1L;
  top = (TCNT1H<<8) + temp;
  TCNT1H = 0;
  TCNT1L = 0;
  top_average = ((U32)top_average*15 + top ) >> 4;
  tmp1 = (top_average >> 1);
  tmp2 = tmp1 + (top_average >> 2);
//  tmp2 = tmp1 + 40;
/*  if (tmp1 > (4*ADVANCE))
  {
    tmp1 = tmp1 - ADVANCE;
    tmp2 = tmp2 - ADVANCE;
  }*/
  OCR1AH = MSB(tmp1);
  OCR1AL = LSB(tmp1);
  OCR1BH = MSB(tmp2);
  OCR1BL = LSB(tmp2);
  TCCR1B = 1<<CS11 | 1<<CS10 ;			// v1Jn
  Disable_IT_comparator2_1_0();
  mc_estimation_speed();
}

#ifdef __GNUC__
  ISR(ANACOMP2_vect)
#else
#pragma vector = ANA_COMP2_vect
__interrupt void mc_comparator_2(void)
#endif
{
  U16 top;
  U16 tmp1;
  U16 tmp2;
  U8 temp;
//Toggle_PE1();
  TCCR1B = 0 ;							// v1~
  temp = TCNT1L;
  top = (TCNT1H<<8) + temp;
  TCNT1H = 0;
  TCNT1L = 0;
  top_average = ((U32)top_average*15 + top ) >> 4;
  tmp1 = (top_average >> 1);
  tmp2 = tmp1 + (top_average >> 2);
//  tmp2 = tmp1 + 40;
/*  if (tmp1 > (4*ADVANCE))
  {
    tmp1 = tmp1 - ADVANCE;
    tmp2 = tmp2 - ADVANCE;
  }*/
  OCR1AH = MSB(tmp1);
  OCR1AL = LSB(tmp1);
  OCR1BH = MSB(tmp2);
  OCR1BL = LSB(tmp2);
  TCCR1B = 1<<CS11 | 1<<CS10 ;			// v1Jn
  Disable_IT_comparator2_1_0();
}

void start_running_phase(void)
{
  U16 top;
  TCCR1B = 0 ;							// v1~
  top_average = TIMER1_AT_STARTUP_END;
  top = (top_average >> 1);
  TCNT1H = HIGH(top);
  TCNT1L = LOW(top);
  OCR1AH = 0;
  OCR1AL = 0;
  top = top + (top_average >> 2);
  OCR1BH = HIGH(top);
  OCR1BL = LOW(top);
  TCCR1B = (1<<CS11) | (1<<CS10) ;		// v1Jn
  TIFR1 = (1<<OCF1B) | (1<<OCF1A) | (1<<TOV1);
  TIMSK1= (1<<OCIE1B) | (1<<OCIE1A);	// rAv荞݋
}

/******************************************************************************/
/******************************************************************************/
/*		v0 : x													  */
/******************************************************************************/
/******************************************************************************/

/**
 * @brief	v0`Ԑݒ
 * v0͈ꔭɊԊuԂ𐶐̂Ɏgp܂B
 * @post	v0
*/
void mc_init_timer0(void)
{
  TCCR0A = 0;
  TCCR0B = (0<<CS02)|(1<<CS01)|(1<<CS00);		// 64Ou(4s)Ŏn
  TIMSK0 = (1<<TOIE0);
}

/**
  * @brief	v04s
*/

#ifdef __GNUC__
  ISR(TIMER0_OVF_vect)
#else
#pragma vector = TIMER0_OVF_vect
__interrupt void ovfl_timer0(void)
#endif
{
  timer0_ext++;
  g_tick = TRUE;
}

/**
* @brief	x
* @pre		v0̌`Ԑݒ\n config_motor.hAVERAGE_SPEED_MEASURENT̗L`
* @post		xɊւVl
*/
void mc_estimation_speed(void)
{
  U16 actual_time;
  U16 period_motor;

  // 28ޯĕϐ16ޯČvЭڰĂ̂Ɏgp܂B
  actual_time = (timer0_ext<<8) + TCNT0;
  if (actual_time > stored_time)
  {
	period_motor = actual_time - stored_time;
  }
  else
  {
	period_motor = (U16)65535 - stored_time + actual_time;
  }
  stored_time = actual_time;
  mc_set_measured_period(period_motor>>1);
}

/******************************************************************************/
/******************************************************************************/
/*		A/Dϊ͓dƉϒȒɎgp								  */
/******************************************************************************/
/******************************************************************************/

//! @brief	dl𓾂邽߂ɍ̎菇Jn
//! @pre	ƊԊuԂ̏
//! @post	ϊI׸ސݒ
#ifdef __GNUC__
  ISR(ADC_vect)
#else
#pragma vector = ADC_vect
__interrupt void ADC_end_of_conversion(void)
#endif
{
  Adc_select_channel(ADC_INPUT_GND);		/* ꂽقJ */
  if(State == CONV_POT) mc_set_potentiometer_value(Adc_get_8_bits_result());
  if(State == CONV_CURRENT) mci_store_measured_current(Adc_get_10_bits_result());
  ADC_State = FREE;
}

//! @brief	A/Dϊp̌v敔Jn
//! @post	ϒRƓd̒ľʂ擾
void mc_ADC_Scheduler(void)
{
  switch(State)
  {
  case CONV_INIT :
	ADC_State = FREE;							// A/Dϊ폀ݒ
	State = CONV_CURRENT;
	break;
  case CONV_CURRENT :							/* dA/DϊԂŁA */
	if(ADC_State == FREE)						// A/Dϊ폀ȂA
	{
	  ADC_State = BUSY;							// A/Dϊ푽Zݒ
	  State= CONV_POT;							// (ϒRA/Dϊ)ݒ
	  Adc_left_adjust_result();					// ʍݒ
	  Adc_start_conv_channel(ADC_INPUT_ISRC);	// ISRC͂ŉϒRlA/DϊJn
	}
	break;
  case CONV_POT :								/* ϒRA/DϊԂŁA */
	if(ADC_State == FREE)						// A/Dϊ폀ȂA
	{
	  ADC_State = BUSY;							// A/Dϊ푽Zݒ
	  State = CONV_CURRENT;						// (dA/Dϊ)ݒ
	  Adc_right_adjust_result();				// ʉEݒ
	  Adc_start_conv_channel(ADC_INPUT_AMP1);	// 1œdlA/DϊJn
	}
	break;
  }
}

/******************************************************************************/
/******************************************************************************/
/*		ߓd`Ԑݒ														  */
/******************************************************************************/
/******************************************************************************/

//! @brief	̊֐̖ړI͎n̉ߓd(d)o֎~邱ƂłB\n
void mc_disable_during_inrush(void)
{
  inrush_delay = (U16) 500;
  inrush_mask_flag = TRUE;
  Disable_over_current();
}

//! @brief	̊֐̖ړI͉ߓdo֎~ɎgpxǗ邱ƂłB\n
void mc_inrush_task(void)
{ 
  if (inrush_mask_flag == TRUE)
  {
	if (inrush_delay-- == 0)
	{
	  inrush_mask_flag = FALSE;
	  Enable_over_current();
    }
  }
}

// ߓdo
#ifdef __GNUC__
  ISR(PSC_FAULT_vect)
#else
#pragma vector = PSC_FAULT_vect
__interrupt void mc_overcurrent_detect(void)
#endif
{
  PIFR = (1<<PEV1);			// 荞ݗv׸މ
  overcurrent = TRUE;
  mci_stop();
}
